#include "solve.h"
#include "petscsnes.h"
#include "physical.h"   
#include <stdlib.h>   
//#include <fenv.h>
    
         



//-----------------------------------------------------------------
int main(int argc, char ** args)
{    
     int i;
     FILE *fp1;
     double p,Temp;
     
     PetscInitialize(&argc,&args,(char *)0,(char *)0);
     
     Solver solver;
     
     printf("1D Diode IV Simulation program\n");
     printf("Writed by gdiso on 04/27/2005\n");
     if(argc!=3)
     {
     	printf("using diode Vapp OutputFile\n");
        exit(0);
     }	
        

     solver.init_diode();  
     solver.init_solver();
     
     //compute equilibrium
     printf("compute equilibrium...\n");
     solver.dt = 1e38;
     solver.do_solver();   
     fp1=fopen("equilibrium.dat","w");
     for(i=0;i<nodes;i++)
     { 
       fprintf(fp1,"%d\t%e\t%e\t%e\t%e\t%e\n",
       i,
       solver.Q[i].p*1e15,
       solver.Q[i].n*1e15,
       solver.Q[i].P,
       solver.Q[i].Na*1e15,
       solver.Q[i].Nd*1e15);
     }
     fclose(fp1);
     
     //compute IV
     printf("compute IV...\n");
     solver.Vapp=atof(args[1]);     
     fp1=fopen(args[2],"w");
     for(solver.Vapp=0.0;solver.Vapp<atof(args[1]);solver.Vapp+=0.01)
     {
     	printf("computing IV curve at Vapp=%e\n",solver.VoltageWave());
     	solver.do_solver();
     	fprintf(fp1,"%e\t%e\n",solver.VoltageWave(),solver.current_cathode());
     } 	
     fclose(fp1);
     
/*     
     //transient simulation
     solver.dt = 1e3;
     solver.end_t = 2e5;
     while((solver.t=solver.t+solver.dt)<solver.end_t)
     {   
         solver.do_solver();
	 fprintf(fp1,"%e\t%e\n",solver.VoltageWave(),solver.current_cathode());
	 printf("time=%e,voltage=%e, current=%e\n\n",solver.t,solver.VoltageWave(),solver.current_cathode());
     }
*/     
     
     solver.destroy_solver();
     PetscFinalize();
      
}

