#include "common.h"
#include "physical.h"
#include <math.h>


//-------------------------------------------------
double mu0n(double Na,double Nd)
{
  return 0.5524+(14.2923-0.5524)/(1+pow((Nd+Na)/107.2,0.73));
} 
 
double mu0p(double Na,double Nd)
{
  return 0.497+(4.7937-0.497)/(1+pow((Nd+Na)/160.6,0.7));
}  	


//-------------------------------------------------------

double R(double Na,double Nd,double p,double n)
{
  double Rsrh,Rauger;
  double taon=1e5/(1+(Nd+Na)/5e1);
  double taop=1e5/(1+(Nd+Na)/5e1);
  Rsrh=(p*n-nie*nie)/(taop*(n+nie)+taon*(p+nie));
  Rauger=2.8e-13*(p*n*n-n*nie*nie)+9.9e-14*(n*p*p-p*nie*nie);
  return Rsrh+Rauger;
}	

/* ----------------------------------------------------------------------------
 * nsdep:  This function returns an approximate deposition profile of a step
 *	   implant driven in an inert environment.
 *
 *			  1	  W/2 + x	   W/2 - x
 *	  nsdep(x,W,Dt) = - (erf(---------) + erf(----------))
 *			  2	 2*sqrt(Dt)	  2*sqrt(Dt)
 */
double nsdep ( double x, double W, double Dt )
{
  double D  = 2.0 * sqrt(Dt);
  double Wh = W / 2.0;
  return 0.5 * (erf((Wh + x)/D) + erf((Wh - x)/D));
}



/* ----------------------------------------------------------------------------
 * ngdep:  This function returns an approximate Gaussian deposition.
 */
double ngdep ( double x,double W, double ax)
{
  double xprime = fabs(x) - W/2.0;
  return ((xprime <= 0.0) ? 1.0 : exp(-ax*xprime*xprime));
}

double Vbi(double Na,double Nd)
{
	return k*Tl/e*asinh((Nd-Na)/(2*nie));
}
