#ifndef _solve_h_
#define _solve_h_
#include "common.h"
#include "petscsnes.h"
class Solver
{
  private:
        //---------------------------------------------------------
	SNES           snes;         /* nonlinear solver context */
	KSP            ksp;          /* linear solver context */
	PC             pc;           /* preconditioner context */
	Vec            x,r;          /* solution, residual vectors */
	Mat            J;            /* Jacobian matrix */	
  public:
	PNDIODE Q[nodes];
	double t,dt,end_t;
	double Vapp;
	void init_diode();
	void init_solver();
 	void do_solver();
	void destroy_solver();
	double VoltageWave();
 	double current_cathode();
 	
 	Solver():Vapp(0),t(0),dt(1e38),end_t(2e4){}
};
 	
#endif
